<template>
  <section class="create-account-form">
    <h3>Criar Conta</h3>
    <form action="" method="post">
      <div>
        <input
          type="email"
          v-model="email"
          placeholder="Email">
        <input-error-message
          :hasError="!validEmail">
          Email inválido
        </input-error-message>
        <input 
          type="password"
          v-model="password"
          placeholder="Senha">
        <input-error-message
          :hasError="!validPass">
          {{ passError }}
        </input-error-message>
      </div>
      <div>
        <p 
          class="submit-error" 
          v-if="submitError">
          {{ submitErrorMessage }}
        </p>
        <p 
          class="submit-error" 
          v-else>
          &nbsp;
        </p>
      </div>
      <button 
        :class="btnClass"
        type="submit"
        @click.prevent="submit"
        :disabled="submitting || !validEmail || !validPass">
        Registrar
      </button>
    </form>
    <h6>
      Cadastrado? <nuxt-link to="/login">Entre no sistema</nuxt-link>
    </h6>
  </section>
</template>

<script>
import InputErrorMessage from '~/components/InputErrorMessage.vue'

export default {
  data() {
    return {
      submitError: false,
      submitting: false,
      btnClass: ["btn", "btn-submit", "btn-touch"],
      errorMessage: ''      
    };
  },
  computed: {
    email: {
      get() {
        return this.$store.getters.signupInfo.email;
      },
      set(value) {
        this.$store.commit('setSignupEmail', value);
      }
    },
    password: {
      get() {
        return this.$store.getters.signupInfo.password;
      },
      set(value) {
        return this.$store.commit('setSignupPassword', value);
      }
    },
    validEmail() {
      let isValid = this.email.match(/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/);
      this.$store.commit('setSignupError', {type: 'email', value: !isValid});
      return isValid;
    },
    passError() {
      if (this.password.length < 8)
        return 'Senha precisa ter pelo menos 8 caracteres';
      
      if (this.password.length > 30)
        return 'Senha só pode ter no máximo 30 caracteres';

      return '';
    },
    validPass() {
      let isValid = this.password.length >= 8 && this.password.length <= 30
      this.$store.commit('setSignupError', {type: 'password', value: !isValid});
      return isValid;
    },
    submitErrorMessage() {
      return this.errorMessage
    }
  },
  methods: {
    formHasError() {
      let signupErrors = this.$store.getters.signupErrors;
      let hasError = Object.keys(signupErrors).map(e => signupErrors[e]);
      return hasError.reduce((acc, item) => acc || item, false)
    },
    submit() {
      if (this.formHasError()) {
        this.errorMessage = ""
        return
      }
      this.submitting = true;
      this.btnClass = this.btnClass.concat("btn-disabled");
      const info = {};
      info.user = this.$store.getters.signupInfo;
      info.user.password_confirmation = info.user.password;
      let ins = this;
      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/signup',
        data: info
      })
        .then( res => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = false;

          // set infos needed for logged user
          ins.$store.commit('setToken', res.data.auth_token);
          ins.$store.commit('setUserEmail', ins.$store.getters.signupInfo.email);

          // clear form data
          ins.$store.commit('clearSignupInfo');

          // redirect
          ins.$router.push('/');
        })
        .catch( error => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = true;
          ins.errorMessage = error.response.data.error
        });
    }
  },
  components: {
    InputErrorMessage
  }
}
</script>
